using System;
using Microsoft.VisualBasic;

namespace ConsoleApplicationExternalAppCalls
{
  class Program
  {
    static void Main(string[] args) {
      try {
        object objAutomCli = Microsoft.VisualBasic.Interaction.GetObject(null, "Telemator.Document");
        object retObj = Microsoft.VisualBasic.Interaction.CallByName(objAutomCli, "ExecuteFromGis", 
                                         CallType.Method, new object[] { "ShowPoint", "CallFromC#" });
        if (retObj != null)
          Write2Console(retObj.ToString(), 1);
      }
      catch(Exception e) {
        Write2Console("Did you forget to start Telemator?", 1);
        Write2Console("Error: " + e.ToString(), 0);
      }

      Console.Write("\nPlease press the Return Key to exit...");
      Console.ReadLine();
    }

    static void Write2Console(String s, int color) {
      Console.ForegroundColor = color == 1 ? ConsoleColor.Green : ConsoleColor.Red;
      Console.WriteLine(s);
      Console.ForegroundColor = ConsoleColor.Gray;
    }
  }
}
