VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Telemator Automation test-client"
   ClientHeight    =   6960
   ClientLeft      =   60
   ClientTop       =   456
   ClientWidth     =   7092
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   6960
   ScaleWidth      =   7092
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text3 
      Height          =   800
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   12
      Text            =   "AutomCli.frx":0000
      Top             =   4920
      Width           =   6615
   End
   Begin VB.TextBox Text5 
      Height          =   800
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   9
      Top             =   3720
      Width           =   6615
   End
   Begin VB.TextBox Text4 
      Height          =   525
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      Text            =   "AutomCli.frx":0006
      Top             =   2880
      Width           =   6615
   End
   Begin VB.Frame Frame1 
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6855
      Begin VB.ComboBox Combo1 
         Height          =   315
         Left            =   120
         TabIndex        =   4
         Text            =   "Combo1"
         ToolTipText     =   "Choose one command in the list"
         Top             =   480
         Width           =   6615
      End
      Begin VB.CommandButton Command2 
         Caption         =   "Send command to Telemator"
         Height          =   495
         Left            =   3720
         TabIndex        =   3
         Top             =   1800
         Width           =   3000
      End
      Begin VB.CommandButton Command1 
         Caption         =   "SetForegroundWindow - Telemator"
         Height          =   495
         Left            =   120
         TabIndex        =   2
         Top             =   1800
         Width           =   3000
      End
      Begin VB.TextBox Text2 
         Height          =   375
         Left            =   120
         TabIndex        =   1
         Text            =   "Text2"
         ToolTipText     =   "Tab separated list of arguments"
         Top             =   1200
         Width           =   6615
      End
      Begin VB.Label Label2 
         Caption         =   "Arguments (semicolon ';' will be translated into <tab>):"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   960
         Width           =   6615
      End
      Begin VB.Label Label1 
         Caption         =   "Command:"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   6615
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "DDE Incomming"
      Height          =   2175
      Left            =   120
      TabIndex        =   10
      Top             =   4680
      Width           =   6855
      Begin VB.Label Label3 
         Caption         =   "dde.ini description comes here..."
         Height          =   960
         Left            =   120
         TabIndex        =   13
         Top             =   1080
         Width           =   6615
      End
   End
   Begin VB.Label Label5 
      Caption         =   "Automation Result (after first tab):"
      Height          =   255
      Left            =   240
      TabIndex        =   11
      Top             =   3480
      Width           =   6615
   End
   Begin VB.Label Label4 
      Caption         =   "Automation Result (before first tab):"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   8
      Top             =   2640
      Width           =   6615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Private Function IsTelematorRunning() As Boolean
  Dim hWnd As Long: hWnd = FindWindow("TelematMainWClass", vbNullString)
  IsTelematorRunning = hWnd <> 0
End Function

Private Function GetTelematorObject(ByRef obj As Object) As Boolean
  GetTelematorObject = False
  On Error GoTo ErrorHandler
  Set obj = GetObject(, "Telemator.Document")
  GetTelematorObject = True
  Exit Function
ErrorHandler:
  If IsTelematorRunning() Then
    MsgBox ("GetTelematorObject failed." & vbLf & _
            "Does registry key HKEY_CLASSES_ROOT\Telemator.Document\CLSID exist?" & vbLf & _
            "(If not - Your login does not have priviliges to create it and " & _
            "Telemator must be run once with administrative priviliges)")
  Else
    MsgBox ("GetTelematorObject failed." & vbLf & "Is Telemator running?")
  End If
End Function

Private Sub SetForegroundWindow_Telemator()
On Error GoTo ErrorHandler
  Dim MyObj As Object, hWndTop As Long
  If GetTelematorObject(MyObj) Then
    hWndTop = MyObj.GetForegroundHwnd()
    If hWndTop <> 0 Then SetForegroundWindow (hWndTop)
  End If
  Exit Sub
ErrorHandler:
  MsgBox ("SetForegroundWindow_Telemator failed")
End Sub

Private Sub ReplaceTextInString(SourceString As String, _
    SearchString As String, ReplaceString As String)
  Dim p As Integer, NewString As String
  Do
    p = InStr(p + 1, UCase(SourceString), UCase(SearchString))
    If p > 0 Then ' replace SearchString with ReplaceString
      NewString = ""
      If p > 1 Then NewString = Mid(SourceString, 1, p - 1)
        NewString = NewString + ReplaceString
        NewString = NewString + Mid(SourceString, p + Len(SearchString), Len(SourceString))
        p = p + Len(ReplaceString) - 1
        SourceString = NewString
      End If
    If p >= Len(NewString) Then p = 0
  Loop Until p = 0
End Sub

Private Sub Command1_Click()
  Call SetForegroundWindow_Telemator
End Sub

Private Sub Command2_Click()
On Error GoTo ErrorHandler
  Dim MyObj As Object, strCmd As String, strArg As String, strRes As String
  Dim i As Integer

  strCmd = Combo1
  i = InStr(1, strCmd, "(") ' Remove from: (
  If i > 0 Then strCmd = Mid(strCmd, 1, i - 1)
  strCmd = RTrim(strCmd)

  strArg = Text2.Text
  Call ReplaceTextInString(strArg, ";", vbTab)

  Text3.Text = ""
  Text4.Text = ""
  Text5.Text = ""
  If GetTelematorObject(MyObj) Then
    strRes = MyObj.ExecuteFromGis(strCmd, strArg)
    ' Alternative: strRes = CallByName(MyObj, "ComExecute", VbMethod, strCmd, strArg)

    ' Split result-string
    i = InStr(1, strRes, vbTab)
    Text4.Text = Mid(strRes, 1, i - 1)
    Text5.Text = Mid(strRes, i + 1)

    If InStr(1, strCmd, "SetForegroundWindowGIS", 1) > 0 Then Exit Sub
    If InStr(1, strCmd, "GetAdoConnectString", 1) > 0 Then Exit Sub
    If InStr(1, strCmd, "GetOdbcConnectString", 1) > 0 Then Exit Sub

    If Val(strRes) >= 0 Then ' Success - Set Telemator as foreground-window
      Call SetForegroundWindow_Telemator
    End If
  End If
  Exit Sub
ErrorHandler:
  MsgBox ("Command2_Click failed")
End Sub

Private Sub Form_LinkExecute(CmdStr As String, Cancel As Integer)
  ' Incomming DDE:
  Me.LinkMode = vbLinkNone   ' ACK incomming command (strange but works)
  Me.LinkMode = vbLinkSource ' Ready to receive more incomming commands
  'Handle the incoming command
  Text3.Text = CmdStr
End Sub

Private Sub Form_Load()
  Me.LinkTopic = "system" ' used as server, see LinkExecute event
  ' Me.LinkMode = vbLinkSource 'Must be set in Form property instead

  Combo1 = "Choose one command"

  Combo1.AddItem ("ShowCable  (cable id)")
  Combo1.AddItem ("ShowCableZoom  (cable id)")
  Combo1.AddItem ("ShowCableTrace  (trace id)")
  Combo1.AddItem ("ShowEnd  (point or equipment id)")
  Combo1.AddItem ("ShowEndZoom  (point or equipment id)")
  Combo1.AddItem ("ShowCirc  (circuit id)")
  Combo1.AddItem ("ShowCustomer  (customer id)")
  Combo1.AddItem ("")
  Combo1.AddItem ("ShowEquipm  (equipment id)")
  Combo1.AddItem ("ShowEquipmZoomCon  (equipment id)")
  Combo1.AddItem ("ShowEquipmZoomTrn  (equipment id)")
  Combo1.AddItem ("ShowPoint (point id)")
  Combo1.AddItem ("ShowPointZoom  (point id)")
  Combo1.AddItem ("")
  Combo1.AddItem ("ShowEndsWithCables( end <tab> end <tab> end ...)")
  Combo1.AddItem ("")
  Combo1.AddItem ("ShowCableAskDelete      (cable id)")
  Combo1.AddItem ("ShowCableTraceAskDelete (trace id)")
  Combo1.AddItem ("ShowEndAskDelete        (point or equipment id)")
  Combo1.AddItem ("ShowCustomerAskDelete   (customer id)")
  Combo1.AddItem ("")
  Combo1.AddItem ("InsertEnd  (point or equipment id)")
  Combo1.AddItem ("ModifyEnd  (point or equipment id)")
  Combo1.AddItem ("CopyEnd    (source point or equipment id <tab> new point/equipment id)")
  Combo1.AddItem ("")

  ' Powel Explorer and TM-GIS uses theese - (Cable traces stored in Telemator)
  Combo1.AddItem ("InsertCableTrace      (trace id <tab> end A <tab> end B <tab> fields=)")
  Combo1.AddItem ("ModifyCableTrace      (trace id <tab> end A <tab> end B <tab> fields=)")
  Combo1.AddItem ("CopyCableTrace        (src trace1 id <tab> dst trace2 id <tab> trace2 end A <tab> trace2 end B <tab> trace2 length)")
  Combo1.AddItem ("SplitCableTraceInPoint(src trace1 id <tab> dst trace2 id <tab> split in point <tab> trace1 length <tab> trace2 length)")
' Combo1.AddItem ("SplitCableTrace       (src trace1 id <tab> dst trace2 id <tab> trace1 end A <tab> trace1 end B <tab> trace2 end A <tab> trace2 end B <tab> trace1 length <tab> trace2 length)")
  Combo1.AddItem ("SpliceDuct            (end <tab> trace1 id <tab> duct1 id <tab> trace2 id <tab> duct2 id <tab> splice type)")
  Combo1.AddItem ("PutCableIntoTraces    (tab separeted list of trace ids)")

  ' elMe uses this
  Combo1.AddItem ("PutDuctIntoTraces  (trace template <tab> end A <tab> end B <tab> tab separeted list of trace ids)")
  Combo1.AddItem ("SpliceDuctDlg (point id )")
  Combo1.AddItem ("")

  ' TM-GIS uses this
  Combo1.AddItem ("PutOneCableIntoTrace ( cable id <tab> trace id <tab> duct id)")
  Combo1.AddItem ("")

  ' NetBas/OpenNIS might use theese instead - (Cable traces stored in external app)
  Combo1.AddItem ("InsertCable      (cable id <tab> end A <tab> end B <tab> fields=)")
  Combo1.AddItem ("ModifyCable      (cable id <tab> end A <tab> end B <tab> fields=)")
  Combo1.AddItem ("CopyCable        (src cable1 id <tab> dst cable2 id <tab> cable2 end A <tab> cable2 end B <tab> cable2 length)")
  Combo1.AddItem ("SplitCableInPoint(src cable1 id <tab> dst cable2 id <tab> split in point <tab> cable1 length <tab> cable2 length)")
' Combo1.AddItem ("SplitCable       (src cable1 id <tab> dst cable2 id <tab> cable1 end A <tab> cable1 end B <tab> cable2 end A <tab> cable2 end B <tab> cable1 length <tab> cable2 length)")
  Combo1.AddItem ("")

  ' Powel NetBas uses theese
  Combo1.AddItem ("InsertCustomer  (customer id <tab> fields=)")
  Combo1.AddItem ("ModifyCustomer  (customer id <tab> fields=)")

  ' When GIS wants to be on top
  Combo1.AddItem ("")
  Combo1.AddItem ("SetForegroundWindowGIS")

  ' Powel NetBase uses theese
  Combo1.AddItem ("")
  Combo1.AddItem ("OpenNetworkAreaInFolder ( path )")
  Combo1.AddItem ("CreateNetworkAreaInFolder ( path, flags )")
  Combo1.AddItem ("MergeNetworkAreaInFolder ( path )")

  ' Ask Telemator for information / DSN less database connection
  Combo1.AddItem ("")
  Combo1.AddItem ("GetOdbcConnectString")
  Combo1.AddItem ("GetAdoConnectString")

  Combo1.AddItem ("GetActiveCable")
  Combo1.AddItem ("GetCableStatusText ( cable id )")
  Combo1.AddItem ("GetUncutAvailableDuctsFromPoint ( point id )")
  Combo1.AddItem ("GetNextFreeId ( table[cable,trace,point] <tab> wanted id )")
  Combo1.AddItem ("IsCableTraceModuleInstalled")


  Text2.Text = ""

  'Combo1.Text = "SplitCableTrace"
  'Text2.Text = "T00043" & vbTab & "T00044" & vbTab & _
  '             "P000013" & vbTab & "P000014" & vbTab & _
  '             "P000014" & vbTab & "P0000111"

  Text3.Text = ""
  Text4.Text = ""

  Label3.Caption = "To receive DDE here the Telemator DDE.INI configuration file should contain:" & vbLf & _
                   "   [ExecuteFromTelemator]" & vbLf & _
                   "   DDEApplication=AutomCli" & vbLf & _
                   "   WindowClassName=ThunderRT6FormDC"
End Sub

